#ifndef NET__H
#define NET__H

#include "ch32v30x_eth.h"
#include "ch32v30x_exti.h"
#include "ch32v30x_rng.h"

/* MII/MDI interface select */
#define PHY_ADDRESS 0x01

#define USE10BASE_T
#ifndef USE10BASE_T
//    #define USE_GIGA_MAC
#ifndef USE_GIGA_MAC
#define USE_FAST_MAC
//#define USE_RMII
#endif
#endif

#define ETH_RXBUFNB 4
#define ETH_TXBUFNB 4

#if 0
#define USE_LOOP_STRUCT 1
#else
#define USE_CHAIN_STRUCT 1
#endif

#define PHY_ANLPAR_SELECTOR_FIELD               0x1F
#define PHY_ANLPAR_SELECTOR_VALUE               0x01       /* 5B'00001 */

typedef struct {
    void *next;
    u32 length;
    u32 buffer;
    ETH_DMADESCTypeDef *descriptor;
} FrameTypeDef;

extern ETH_DMADESCTypeDef *DMATxDescToSet;
extern ETH_DMADESCTypeDef *DMARxDescToGet;

extern ETH_DMADESCTypeDef DMARxDscrTab[ETH_RXBUFNB]; /* 接收描述符表 */
extern ETH_DMADESCTypeDef DMATxDscrTab[ETH_TXBUFNB]; /* 发送描述符表 */

extern uint32_t ETH_TxPkt_ChainMode(u16 FrameLength);
void mac_send(uint8_t *content_ptr, uint16_t content_len);

extern FrameTypeDef ETH_RxPkt_ChainMode(void);

extern void PHY_control_pin_init(void);
extern void GETH_pin_init(void);
extern void FETH_pin_init(void);

#define ROM_CFG_USERADR_ID                   0x1FFFF7E8

extern void WCH_GetMacAddr(uint8_t *p);

void init_phy(void);
void Ethernet_LED_LINKSET(uint8_t setbit);
void Ethernet_LED_DATASET(uint8_t setbit);
extern uint32_t led_data_counter;
#endif
